;*********************************************************************
	TITLE "     
			; R-2R"
        LIST P=16F84A	;
        INCLUDE 	<P16F84A.INC>
;*********************************************************************
;       :           SINE.ASM
;	:		   4   
;       :           12/20/95
;	:	MPASM V02.80
;       :          4 Mhz
;       Inst Clk:       1 Mhz (1,000 mKs)
;*********************************************************************
;       :    
;	    F=2000 
;  0 - 7   R-2R   . 
;     32   ,
;    .
;	     
;     .  	
;       		
;       .	
;	   N = 100%/(k)% (  
;	            			 )
;	   = ( )( )
;		    	N x F
;	:
;	  2000 ,    <3%                    
;	   = 100%/3% = 33,3                  
;	  T = 1/F =1/2000 = 0,5 Ms 
;	       = T/32 = 15,6 mKs		
;*************************    *********************
;FXTAL	EQU     .4000000	     	;  4 
;FINST  	EQU     FXTAL/4	     	;    1
;FSINE  	EQU     .2000			     ;        
STEP#		EQU	  .32				;    
									     	;  
;*************************   *********************
TEMP	   	        EQU	0x0C			;    W
STEPCOUNT	   EQU	0x0D			;   
;*********************************************************************
;				 
;*********************************************************************
        org              0x000           
        goto            Start			;   
;*********************************************************************
; 
;*********************************************************************
Start
	    clrf            STATUS			;   STATUS 
	    bsf            STATUS,RP0       ;     1
	    movlw	  0x88		     	;   OPTION_REG		
	    movwf	  OPTION_REG 	;  TMR0 1:1 , PORTB 
         movlw      0xFF		     	;    
         movwf      TRISA                 ;  Port_A  
         clrf            TRISB                  ;  Port_B  
         bcf            STATUS,RP0       ;     0
        movwf	  PORTB		      	;     PORT_B 
ResetStep
        movlw   STEP#
;
        movwf   STEPCOUNT		;    32 
StepLoop
;       call    SetupDelay	          	;     1 
        movf    STEPCOUNT,W   	;      W
        call    SineTable	          	;      
	    call	 SetPortB	               	;        R-2R
        decfsz  STEPCOUNT,F    	;   
        goto    StepLoop	          	;  32 - 20h
        goto    ResetStep	          	;   0 
;*********************************************************************
;             
;	  R-2R
;*********************************************************************
SetPortB
		  movwf   PORTB 
		  return						    ; 
;*********************************************************************
;   	      
;	32       0.1*Vddo 
;	0.9*Vdd (0.5 to 4.5 )  . 
;*********************************************************************
SineTable
	   addwf	 PCL,F	;    
        retlw   .0  		;   
        retlw   .128		; 0 , 2.5 
        retlw   .148
        retlw   .167
        retlw   .185
        retlw   .200
        retlw   .213
        retlw   .222
        retlw   .228
        retlw   .230		; 90 , 4.5 
        retlw   .228
        retlw   .222
        retlw   .213
        retlw   .200
        retlw   .185
        retlw   .167
        retlw   .148
        retlw   .128		; 180 , 2.5 
        retlw   .108
        retlw   .89
        retlw   .71
        retlw   .56
        retlw   .43
        retlw   .34
        retlw   .28
        retlw   .26		; 270 , 0.5 
        retlw   .28
        retlw   .34
        retlw   .43
        retlw   .56
        retlw   .71
        retlw   .89
        retlw   .108
;
;*********************************************************************
;         
;	     
;	32     F = 2000 . 
;*********************************************************************
;							     	;    
SetupDelay			         	;  =16  F=       F=4 
     	movlw   .2		     	;     K=8   F=
      	movwf   TEMP		;     K=4   F=
loop	     			          	;     K=3   F=
     	decfsz  TEMP,F   	;     K=2   F=
							     	;
   	     goto    loop	      	;     K=1   F=2071  
							       	;
         return			     	;     K=1   F=5178   F=10 
							     	;
        END				     	;   

